/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.system.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.kintai.common.action.KintaiCommonAction;
import jp.mosp.kintai.common.dao.MKaisyaDao;
import jp.mosp.kintai.common.dto.MKaisyaDto;
import jp.mosp.kintai.system.vo.KaisyaMasterCardVo;

/**
 * @author yoshida
 *
 */
public class KaisyaMasterCardAction extends KintaiCommonAction {
	
	// コマンド
	private static final String	CMD_KAISYA_MASTER_CARD_SHOW		= "S2015";	// 表示(追加)
	private static final String	CMD_KAISYA_MASTER_CARD_SELECT	= "S2016";	// 表示(選択)
	private static final String	CMD_KAISYA_MASTER_CARD_INSERT	= "S2017";	// 登録
	private static final String	CMD_KAISYA_MASTER_CARD_UPDATE	= "S2018";	// 更新
	private static final String	CMD_KAISYA_MASTER_CARD_DELETE	= "S2019";	// 削除
																			
	
	/**
	 * コンストラクタ
	 */
	public KaisyaMasterCardAction() {
		super();
	}
	
	public void action() throws Exception {
		// VOの取得		
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_KAISYA_MASTER_CARD_SHOW)) {
			// 表示
			show();
		} else if (cmd.equals(CMD_KAISYA_MASTER_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_KAISYA_MASTER_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_KAISYA_MASTER_CARD_UPDATE)) {
			// 更新
			update();
		} else if (cmd.equals(CMD_KAISYA_MASTER_CARD_DELETE)) {
			// 削除
			delete();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new KaisyaMasterCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// PAYROLL権限確認
		confirmSystemAuth();
		KaisyaMasterCardVo vo = (KaisyaMasterCardVo)getVo();
		// 厚生年金基金加入表示方法プルダウンリスト作成
		vo.aryPltKikinKbn = StringUtil.getFlagArray(CommonConst.NAM_FUND_NOT_PARTICIPATION,
				CommonConst.NAM_FUND_PARTICIPATION);
	}
	
	@Override
	protected void show() {
		KaisyaMasterCardVo vo = (KaisyaMasterCardVo)getVo();
		vo.setDefaultValues();
		vo.setMode(KaisyaMasterCardVo.MODE_INSERT);
	}
	
	@Override
	protected void select() throws Exception {
		KaisyaMasterCardVo vo = (KaisyaMasterCardVo)getVo();
		// データの取得
		MKaisyaDto dto = part().office().getMKaisyaDao().findForKey(key1);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		setMode();
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		KaisyaMasterCardVo vo = (KaisyaMasterCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		MKaisyaDto dto = new MKaisyaDto();
		vo.setDtoFields(dto);
		// DAOの準備
		MKaisyaDao dao = part().office().getMKaisyaDao();
		// 存在チェック
		chkDuplicate(dao.findForKey(dto.getId()));
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		dto = dao.findForKey(dto.getId());
		chkInsert(dto);
		// コミット
		commit();
		// モード設定
		setMode();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得		
		MKaisyaDto dto = (MKaisyaDto)getSessionDto();
		KaisyaMasterCardVo vo = (KaisyaMasterCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		vo.setDtoFields(dto);
		// DAOの準備
		MKaisyaDao dao = part().office().getMKaisyaDao();
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(dto.getId()));
		// データの更新
		dao.update(dto);
		// DTOの再取得
		MKaisyaDto retDto = dao.findForKey(dto.getId());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		setMode();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	/**
	 * データ削除
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void delete() throws Exception {
		// DTOの取得		
		MKaisyaDto dto = (MKaisyaDto)getSessionDto();
		KaisyaMasterCardVo vo = (KaisyaMasterCardVo)getVo();
		// データの更新
		part().office().getMKaisyaDao().delete(dto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_DELETE, ""));
	}
	
	/**
	 * モード設定
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void setMode() throws Exception {
		KaisyaMasterCardVo vo = (KaisyaMasterCardVo)getVo();
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(KaisyaMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(KaisyaMasterCardVo.MODE_UPDATE);
		}
	}
	
}
